#include<stdio.h>
#include<stdlib.h>

int tsprime(int n);

typedef struct{
        int* data;
        int cap;
        int size;
} vec;

void v_init(vec* v, int cap);
void v_push(vec* v, int data);
void v_delete(vec*, int index);

int main(int argc, char** argv){
    int n, i, j;

    vec* v = malloc(sizeof(vec));

    scanf("%d", &n);

    v_init(v, n);

    for(i = 0; i < n; ++i){
        scanf("%d", &v->data[i]);
        v->size++;
    }
    for(i = 0; i < v->size; ++i){
        printf("%d ", v->data[i]);
    }
    printf("\n");

    int winner = 1;
    int del = -1;

    while(1){
        printf("start\n");
        printf("size; %d\n", v->size);
        for(i = 0; i < v->size; ++i){
                if(tsprime(v->data[i]) == -1){
                    printf("removing %d\n", v->data[i]);
                    v_delete(v, i);
                }
        }
        if(v->size == 0){
                puts("size is 0");
                winner *= -1;
                break;
        }
        for(i = 0; i < v->size; ++i){
            printf("%d ", v->data[i]);
        }
        printf("\n");
    }

    return 0;
}

void v_delete(vec* v, int index){
        int i;
        v->data[index] = -1;
        for(i = index; i < v->size; ++i){
                v->data[i] = v->data[i+1];
                v->data[i+1] = -1;
        }
        v->size--;
}

void v_push(vec* v, int data){
        if(v->size == v->cap){
                realloc(v, v->cap * 2);
        }

        v->data[v->size] = data;
        v->size++;
}

void v_init(vec* v, int cap){
    v->data = malloc(sizeof(int) * cap);
    v->cap = cap;
    v->size = 0;
}

int tsprime(int n){
        int i;

        for(i = n / 2; i > 1; --i){
            if(i < 2)
                return -1;

                if(n % i != 0){
                    return i;
                }
        }

        return -1;
}
